Index: tmp/org.txm.specificities.core/src/org/txm/specificities/core/statsengine/r/function/SpecificitiesImpl.java
===================================================================
--- tmp/org.txm.specificities.core/src/org/txm/specificities/core/statsengine/r/function/SpecificitiesImpl.java	(revision 0)
+++ tmp/org.txm.specificities.core/src/org/txm/specificities/core/statsengine/r/function/SpecificitiesImpl.java	(revision 313)
@@ -0,0 +1,157 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate: 2017-01-24 18:11:42 +0100 (Tue, 24 Jan 2017) $
+// $LastChangedRevision: 3400 $
+// $LastChangedBy: mdecorde $ 
+//
+package org.txm.specificities.core.statsengine.r.function;
+
+import org.rosuda.REngine.REXP;
+import org.rosuda.REngine.REXPMismatchException;
+import org.rosuda.REngine.Rserve.RserveException;
+import org.txm.lexicaltable.core.statsengine.data.ILexicalTable;
+import org.txm.lexicaltable.core.statsengine.r.data.LexicalTableImpl;
+import org.txm.specificities.core.messages.SpecificitiesCoreMessages;
+import org.txm.specificities.core.statsengine.data.ISpecificities;
+import org.txm.statsengine.core.StatException;
+import org.txm.statsengine.core.data.QuantitativeDataStructure;
+import org.txm.statsengine.core.data.Vector;
+import org.txm.statsengine.r.core.RWorkspace;
+import org.txm.statsengine.r.core.data.MatrixImpl;
+import org.txm.statsengine.r.core.data.VectorImpl;
+import org.txm.statsengine.r.core.exceptions.RWorkspaceException;
+import org.txm.utils.logger.Log;
+
+// TODO: Auto-generated Javadoc
+/**
+ * Bridge between the statistical engine and the high-level specificities
+ * function {@link org.txm.functions.specificities.Specificities}.
+ * 
+ * This class contains only one methods; it takes as input low-level object (a
+ * {@link QuantitativeDataStructure}) and return a low level object (a
+ * <int>double[][]</int> array of specificities index).
+ * 
+ * @author sloiseau
+ * 
+ */
+public class SpecificitiesImpl extends MatrixImpl implements ISpecificities {
+
+	protected static int specif_counter = 1;
+	/** The DEFAULT symbol. */
+	public static final String prefixR = "SpecifResult"; //$NON-NLS-1$
+
+	protected double[][] specIndex;
+
+	/**
+	 * With an already computed specificities score matrix
+	 * @param symbol
+	 * @throws RWorkspaceException
+	 */
+	public SpecificitiesImpl(String symbol) throws RWorkspaceException {
+		super(symbol);
+	}
+
+	public SpecificitiesImpl(ILexicalTable lt) throws StatException {
+		super(prefixR+(specif_counter++));
+
+
+		// Create a set of the existing types
+		String[] rownames = lt.getRowNames().asStringsArray();
+		String[] colnames = lt.getColNames().asStringsArray();
+
+		//System.out.println("Av specif ");
+		specIndex = compute(symbol, lt, rownames, colnames);
+	}
+
+	/**
+	 * compute Specificites of subcorpus using the textometry package functions.
+	 *
+	 * @param lexicon the lexicon
+	 * @param subLexicon the sub lexicon
+	 * @return the double[][]
+	 * @throws StatException the stat exception
+	 * @throws REXPMismatchException 
+	 * @throws RserveException 
+	 */
+	public SpecificitiesImpl(Vector lexicon, Vector subLexicon)
+			throws StatException, RserveException, REXPMismatchException {
+		super(prefixR+(specif_counter++));
+
+		RWorkspace rw = RWorkspace.getRWorkspaceInstance();
+		rw.safeEval("library(textometry)");
+		REXP r = rw.callFunction(
+				"specificities.lexicon.new", new QuantitativeDataStructure[] { lexicon, subLexicon }, symbol); //$NON-NLS-1$
+		// double[] res = RWorkspace.toDouble(r);
+		//System.out.println(" build double matrix");
+		specIndex = r.asDoubleMatrix();
+	}
+
+	/**
+	 * compute Specificites of lexical table using the textometry package functions.
+	 *
+	 * @param table the table
+	 * @param typeFocus the type focus
+	 * @param partFocus the part focus
+	 * @return the double[][]
+	 * @throws StatException the stat exception
+	 */
+	protected static double[][] compute(String symbol, ILexicalTable table,
+			String[] typeFocus, String[] partFocus) throws StatException {
+
+		RWorkspace rw = RWorkspace.getRWorkspaceInstance();
+
+		VectorImpl row = null;
+		if (typeFocus != null && typeFocus.length != 0)
+			row = new VectorImpl(typeFocus);
+
+		VectorImpl column = null;
+		if (partFocus != null && partFocus.length != 0)
+			column = new VectorImpl(partFocus);
+
+		try {
+			rw.safeEval("library(textometry)");
+		} catch (RserveException e1) {
+			// TODO Auto-generated catch block
+			e1.printStackTrace();
+		} catch (REXPMismatchException e1) {
+			// TODO Auto-generated catch block
+			e1.printStackTrace();
+		}
+		REXP r = rw.callFunction("specificities", new QuantitativeDataStructure[] { table, row, column }, symbol); //$NON-NLS-1$
+
+		double[][] res;
+		try {
+			res = r.asDoubleMatrix();
+		} catch (REXPMismatchException e) {
+			throw new StatException(SpecificitiesCoreMessages.ComputeError_FAILED_TO_GET_SPECIFICITIES + e.getMessage(), e);
+		}
+		Log.finest((res.length * res[0].length) + SpecificitiesCoreMessages.Specificites_2);
+
+		return res;
+	}
+
+	public double[][] getScores() {
+		return specIndex;
+	}
+}

Index: tmp/org.txm.specificities.core/src/org/txm/functions/contrasts/Contrast.java
===================================================================
--- tmp/org.txm.specificities.core/src/org/txm/functions/contrasts/Contrast.java	(revision 312)
+++ tmp/org.txm.specificities.core/src/org/txm/functions/contrasts/Contrast.java	(revision 313)
@@ -9,8 +9,9 @@
 
 import org.txm.chartsengine.r.core.themes.DefaultTheme;
 import org.txm.core.results.TXMResult;
+import org.txm.lexicaltable.core.functions.LexicalTable;
 import org.txm.lexicaltable.core.functions.LexicalTableFactory;
-import org.txm.lexicaltable.core.statsengine.data.LexicalTable;
+import org.txm.lexicaltable.core.statsengine.data.ILexicalTable;
 import org.txm.lexicaltable.core.statsengine.r.data.LexicalTableImpl;
 import org.txm.lexicon.core.corpusengine.cqp.Lexicon;
 //import org.txm.progression.core.functions.Progression;
@@ -28,7 +29,9 @@
 
 public abstract class Contrast extends TXMResult {
 
-	protected String symbol;
+	protected static int no_contrast = 1;
+	
+	protected String symbol; // the R table that stores the freqs + indices
 	protected LexicalTable table;
 
 	protected double[][] indices;
@@ -40,24 +43,17 @@
 			throw new IllegalArgumentException(SpecificitiesCoreMessages.ComputeError_NEED_AT_LEAST_2_PARTS);
 		}
 		table = LexicalTableFactory.getLexicalTable(partition, property, Fmin);
-		
+		symbol = "Contrast_"+this.getClass().getSimpleName()+"_"+(no_contrast++);
 	}
 
 	public Contrast(LexicalTable table) {
 		this.table = table;
+		symbol = "Contrast_"+this.getClass().getSimpleName()+"_"+(no_contrast++);
 	}
 
 	public Contrast(Corpus corpus, Subcorpus subcorpus, Property property) throws StatException, CqiClientException {
-		Lexicon totalFrequencies = corpus.getLexicon(property);
-		Lexicon subFrequencies = subcorpus.getLexicon(property);
-
-		Vector totalFSymbol = totalFrequencies.asVector();
-		Vector subFSymbol = subFrequencies.asVector();
-
-		String symbol = RWorkspace.getRandomSymbol();
-		RWorkspace.getRWorkspaceInstance().eval(symbol + " <-  lexiconsToLexicalTable("+totalFSymbol.getSymbol()+", "+subFSymbol.getSymbol()+");"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-		table = new LexicalTableImpl(symbol);
-		table.setCorpus(corpus);
+		table = new LexicalTable(corpus, subcorpus);
+		symbol = "Contrast_"+this.getClass().getSimpleName()+"_"+(no_contrast++);
 	}
 
 	public abstract boolean compute() throws Exception;
@@ -85,9 +81,11 @@
 	}
 
 	public void reloadValues() throws StatException {
-		colNames = table.getColNames().asStringsArray();
-		rowNames = table.getRowNames().asStringsArray();
-		frequencies = RWorkspace.getRWorkspaceInstance().evalToInt2D(table.getSymbol());
+		
+		colNames = table.getData().getColNames().asStringsArray();
+		rowNames = table.getData().getRowNames().asStringsArray();
+		frequencies = RWorkspace.getRWorkspaceInstance().evalToInt2D(table.getData().getSymbol());
+		
 		indices = RWorkspace.getRWorkspaceInstance().evalToDouble2D(symbol);
 	}
 
Index: tmp/org.txm.specificities.core/src/org/txm/functions/contrasts/RelativeFrequency.java
===================================================================
--- tmp/org.txm.specificities.core/src/org/txm/functions/contrasts/RelativeFrequency.java	(revision 312)
+++ tmp/org.txm.specificities.core/src/org/txm/functions/contrasts/RelativeFrequency.java	(revision 313)
@@ -1,7 +1,8 @@
 package org.txm.functions.contrasts;
 
 import org.txm.core.messages.TXMCoreMessages;
-import org.txm.lexicaltable.core.statsengine.data.LexicalTable;
+import org.txm.lexicaltable.core.functions.LexicalTable;
+import org.txm.lexicaltable.core.statsengine.data.ILexicalTable;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.Corpus;
 import org.txm.searchengine.cqp.corpus.Partition;
@@ -12,6 +13,8 @@
 
 public class RelativeFrequency extends Contrast {
 	
+	private ILexicalTable itable;
+	
 	public RelativeFrequency(Corpus corpus, Subcorpus subcorpus, Property property)
 			throws StatException, CqiClientException {
 		super(corpus, subcorpus, property);
@@ -31,12 +34,13 @@
 
 	@Override
 	public boolean compute() throws StatException {
-		colNames = table.getColNames().asStringsArray();
-		rowNames = table.getRowNames().asStringsArray();
-		frequencies = RWorkspace.getRWorkspaceInstance().evalToInt2D(table.getSymbol());
+		itable = table.getData();
+		colNames = itable.getColNames().asStringsArray();
+		rowNames = itable.getRowNames().asStringsArray();
+		frequencies = RWorkspace.getRWorkspaceInstance().evalToInt2D(itable.getSymbol());
 		
 		// compute
-		String cmd = symbol +" <- 100*"+table.getSymbol()+" / rowSums("+table.getSymbol()+")"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+		String cmd = symbol +" <- 100*"+itable.getSymbol()+" / rowSums("+itable.getSymbol()+")"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
 		indices = RWorkspace.getRWorkspaceInstance().evalToDouble2D(cmd);
 		return true;
 	}
Index: tmp/org.txm.specificities.core/src/org/txm/functions/contrasts/Contrasts.java
===================================================================
--- tmp/org.txm.specificities.core/src/org/txm/functions/contrasts/Contrasts.java	(revision 312)
+++ tmp/org.txm.specificities.core/src/org/txm/functions/contrasts/Contrasts.java	(revision 313)
@@ -3,12 +3,13 @@
 import java.util.ArrayList;
 
 import org.txm.core.messages.TXMCoreMessages;
-import org.txm.lexicaltable.core.statsengine.data.LexicalTable;
+import org.txm.lexicaltable.core.functions.LexicalTable;
 import org.txm.specificities.core.functions.Chi2;
 import org.txm.specificities.core.functions.Specificites2;
 
 public class Contrasts {
 	LexicalTable table;
+	
 	ArrayList<Contrast> mesures = new ArrayList<Contrast>();
 	ArrayList<ContrastMethod> methods;
 	
Index: tmp/org.txm.specificities.core/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.specificities.core/META-INF/MANIFEST.MF	(revision 312)
+++ tmp/org.txm.specificities.core/META-INF/MANIFEST.MF	(revision 313)
@@ -4,15 +4,16 @@
 Bundle-SymbolicName: org.txm.specificities.core;singleton:=true
 Bundle-Version: 1.0.0.qualifier
 Bundle-RequiredExecutionEnvironment: JavaSE-1.6
-Require-Bundle: org.txm.statsengine.core;bundle-version="1.0.0",
+Require-Bundle: org.txm.statsengine.r.core,
+ org.txm.lexicon.core;bundle-version="1.0.0",
+ org.txm.lexicaltable.core;bundle-version="1.0.0",
+ org.txm.statsengine.core;bundle-version="1.0.0",
  org.txm.core;bundle-version="0.7.0",
  org.txm.progression.core;bundle-version="1.0.0",
  org.txm.chartsengine.core;bundle-version="1.0.0",
  org.txm.chartsengine.jfreechart.core;bundle-version="1.0.0",
  org.txm.chartsengine.r.core;bundle-version="1.0.0",
- org.eclipse.core.runtime;bundle-version="3.10.0",
- org.txm.lexicaltable.core;bundle-version="1.0.0",
- org.txm.lexicon.core;bundle-version="1.0.0"
+ org.eclipse.core.runtime;bundle-version="3.10.0"
 Export-Package: org.txm.functions.contrasts,
  org.txm.specificities.core.chartsengine.jfreechart,
  org.txm.specificities.core.chartsengine.r,
Index: tmp/org.txm.statsengine.core/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.statsengine.core/META-INF/MANIFEST.MF	(revision 312)
+++ tmp/org.txm.statsengine.core/META-INF/MANIFEST.MF	(revision 313)
@@ -11,3 +11,4 @@
 Require-Bundle: org.txm.core;bundle-version="0.7.0",
  org.txm.utils;bundle-version="1.0.0"
 Bundle-Vendor: Textometrie.org
+Import-Package: org.eclipse.osgi.util
Index: tmp/org.txm.statsengine.core/src/org/txm/statsengine/core/messages/StatsEngineCoreMessages.java
===================================================================
--- tmp/org.txm.statsengine.core/src/org/txm/statsengine/core/messages/StatsEngineCoreMessages.java	(revision 312)
+++ tmp/org.txm.statsengine.core/src/org/txm/statsengine/core/messages/StatsEngineCoreMessages.java	(revision 313)
@@ -1,8 +1,9 @@
 package org.txm.statsengine.core.messages;
 
+import org.eclipse.osgi.util.NLS;
 import org.txm.utils.messages.Utf8NLS;
 
-public class StatsEngineCoreMessages extends Utf8NLS {
+public class StatsEngineCoreMessages extends NLS {
 
 	private static final String BUNDLE_NAME = "org.txm.statsengine.core.messages.messages"; //$NON-NLS-1$
 
Index: tmp/org.txm.cah.core/src/org/txm/cah/core/functions/CAH.java
===================================================================
--- tmp/org.txm.cah.core/src/org/txm/cah/core/functions/CAH.java	(revision 312)
+++ tmp/org.txm.cah.core/src/org/txm/cah/core/functions/CAH.java	(revision 313)
@@ -35,7 +35,7 @@
 import org.txm.cah.core.messages.CAHCoreMessages;
 import org.txm.core.results.ITXMResult;
 import org.txm.functions.Function;
-import org.txm.lexicaltable.core.statsengine.data.LexicalTable;
+import org.txm.lexicaltable.core.functions.LexicalTable;
 import org.txm.searchengine.cqp.corpus.Corpus;
 import org.txm.searchengine.cqp.corpus.Partition;
 import org.txm.statsengine.r.core.RWorkspace;
@@ -113,7 +113,6 @@
 	protected CA ca;
 	protected LexicalTable table;
 
-
 	/**
 	 * Instantiates a new cAH.
 	 *
@@ -160,7 +159,7 @@
 		this.source = table;
 		this.partition = table.getPartition();
 		this.corpus = table.getCorpus();
-		this.target = table.getSymbol();
+		this.target = table.getData().getSymbol();
 		this.table = table;
 	}
 
Index: tmp/org.txm.core/src/java/org/txm/core/preferences/TXMPreferences.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/core/preferences/TXMPreferences.java	(revision 312)
+++ tmp/org.txm.core/src/java/org/txm/core/preferences/TXMPreferences.java	(revision 313)
@@ -509,6 +509,10 @@
 	public static void put(String nodeQualifier, String key, String value) {
 		scope.getNode(nodeQualifier).put(key, value);
 	}
+	
+	public static void putString(String nodeQualifier, String key, String value) {
+		scope.getNode(nodeQualifier).put(key, value);
+	}
 
 	/**
 	 * 
Index: tmp/org.txm.core/src/java/org/txm/core/preferences/TBXPreferences.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/core/preferences/TBXPreferences.java	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/core/preferences/TBXPreferences.java	(revision 313)
@@ -0,0 +1,125 @@
+package org.txm.core.preferences;
+
+import org.txm.core.messages.TXMCoreMessages;
+import org.txm.utils.logger.Log;
+
+public class TBXPreferences extends TXMPreferences {
+
+	public static String PREFERENCES_NODE = TBXPreferences.class.getCanonicalName();
+	
+	/** The Constants for Toolbox properties. */
+	public static final String LOG_LEVEL = "log_level"; //$NON-NLS-1$
+	public static final String ADD_TECH_LOGS = "log_in_console"; //$NON-NLS-1$
+	public static final String SHOW_TIMINGS = "show_timings"; //$NON-NLS-1$
+	public static final String LOG_DIR = "log_directory"; //$NON-NLS-1$
+	public static final String LOG_IN_FILE = "log_in_file"; //$NON-NLS-1$
+	public static final String EXPERT_USER = "txm_expert_user"; //$NON-NLS-1$
+	public static final String LOG_STACKTRACE = "log_stacktrace"; //$NON-NLS-1$
+
+	/** The Constant CQI_SERVER_HOST. */
+	public static final String CQI_SERVER_HOST = "cqi_server_host"; //$NON-NLS-1$
+
+	/** The Constant CQI_SERVER_PORT. */
+	public static final String CQI_SERVER_PORT = "cqi_server_port"; //$NON-NLS-1$
+
+	/** The Constant CQI_SERVER_LOGIN. */
+	public static final String CQI_SERVER_LOGIN = "cqi_server_login"; //$NON-NLS-1$
+
+	/** The Constant CQI_SERVER_PASSWORD. */
+	public static final String CQI_SERVER_PASSWORD = "cqi_server_password"; //$NON-NLS-1$
+
+	/** The Constant CQI_SERVER_PATH_TO_EXECUTABLE. */
+	public static final String CQI_SERVER_PATH_TO_EXECUTABLE = "cqi_server_path_to_executable"; //$NON-NLS-1$
+
+	public static final String CQI_SERVER_PATH_TO_CQPLIB = "cqi_server_path_to_cqplib"; //$NON-NLS-1$
+
+	/** The Constant CQI_SERVER_PATH_TO_INIT_FILE. */
+	public static final String CQI_SERVER_PATH_TO_INIT_FILE = "cqi_server_path_to_init_file"; //$NON-NLS-1$
+
+	/** The Constant CQI_SERVER_ADDITIONAL_OPTIONS. */
+	public static final String CQI_SERVER_ADDITIONAL_OPTIONS = "cqi_server_additional_options"; //$NON-NLS-1$
+
+	/** The Constant CQI_SERVER_MONITOR_OUTPUT. */
+	public static final String CQI_SERVER_MONITOR_OUTPUT = "cqi_server_monitor_output"; //$NON-NLS-1$
+
+	/** The Constant CQI_SERVER_IS_REMOTE. */
+	public static final String CQI_SERVER_IS_REMOTE = "cqi_server_is_remote"; //$NON-NLS-1$
+
+	/** The Constant CQI_SERVER_MODE. */
+	public static final String CQI_NETWORK_MODE = "cqi_server_mode"; //$NON-NLS-1$
+
+	public static final String CQP_EMPTY_VALUE_CODE = "cqp_empty_value_code";
+
+	/** The Constant SCRIPT_ROOT_DIR. */
+	public static final String SCRIPT_ROOT_DIR = "script_root_dir"; //$NON-NLS-1$
+
+	/** The Constant SCRIPT_CURRENT_DIR. */
+	public static final String SCRIPT_CURRENT_DIR = "script_current_dir"; //$NON-NLS-1$
+
+	/** The Constant UI_LOCALE. */
+	public static final String UI_LOCALE = "ui_locale"; //$NON-NLS-1$
+
+	/** The Constant WORKSPACE_LOCATION. */
+	public static final String WORKSPACE_LOCATION = "workspace_location"; //$NON-NLS-1$
+
+	/** The Constant INSTALL_DIR. */
+	public static final String INSTALL_DIR = "install_dir"; //$NON-NLS-1$
+
+	/** The Constant USER_TXM_HOME. */
+	public static final String USER_TXM_HOME = "user_txm_home"; //$NON-NLS-1$
+
+	/** The Constant TREETAGGER_INSTALL_PATH. */
+	public static final String TREETAGGER_INSTALL_PATH = "treetagger_install_path"; //$NON-NLS-1$
+	/** The Constant TREETAGGER_MODELS_PATH. */
+	public static final String TREETAGGER_MODELS_PATH = "treetagger_models_path"; //$NON-NLS-1$
+	public static final String TREETAGGER_OPTIONS = "treetagger_options"; //$NON-NLS-1$
+	public static final String TREETAGGER_APOSTROPHE = "treetagger_fix_apostrophes"; //$NON-NLS-1$
+
+	public static final String METADATA_ENCODING = "metadata_encoding"; //$NON-NLS-1$
+	public static final String METADATA_COLSEPARATOR = "metadata_colseparator"; //$NON-NLS-1$
+	public static final String METADATA_TXTSEPARATOR = "metadata_txtseparator"; //$NON-NLS-1$
+
+	/** Contains all the parameters keys. */
+	public static final String[] existingKeys = { LOG_LEVEL, LOG_STACKTRACE, ADD_TECH_LOGS, LOG_DIR,
+		LOG_IN_FILE, CQI_SERVER_HOST, CQI_SERVER_PORT, CQI_SERVER_LOGIN,
+		CQI_SERVER_PASSWORD, CQI_SERVER_PATH_TO_EXECUTABLE,CQI_SERVER_PATH_TO_CQPLIB,
+		CQI_SERVER_ADDITIONAL_OPTIONS, CQI_SERVER_MONITOR_OUTPUT,
+		CQI_SERVER_IS_REMOTE, CQI_NETWORK_MODE, CQP_EMPTY_VALUE_CODE, SCRIPT_ROOT_DIR,
+		SCRIPT_CURRENT_DIR, UI_LOCALE, WORKSPACE_LOCATION, INSTALL_DIR,
+		USER_TXM_HOME,
+		//		IS_R_MANDATORY, R_PATH_TO_EXECUTABLE, R_DEBUG, R_REMOTE, R_SERVER_ADDRESS,
+		//		R_PORT, R_USER, R_PASSWORD, R_PACKAGES_PATH, R_RARGS, R_RSERVEARGS, R_DISABLE, R_FILE_TRANSFERT,R_SVG_DEVICE,
+
+		TREETAGGER_INSTALL_PATH, TREETAGGER_MODELS_PATH,TREETAGGER_OPTIONS, TREETAGGER_APOSTROPHE,
+		METADATA_ENCODING, METADATA_COLSEPARATOR,METADATA_TXTSEPARATOR
+
+	};
+
+	public static String getID() {
+		return "org.txm.core";
+	}
+
+	@Override
+	public void initializeDefaultPreferences() {
+		Log.info(TXMCoreMessages.Toolbox_4 + TBXPreferences.getID()); 
+
+		TXMPreferences.putString(TBXPreferences.class.getCanonicalName(),TBXPreferences.LOG_LEVEL, "OFF"); //$NON-NLS-1$
+		TXMPreferences.putString(TBXPreferences.class.getCanonicalName(),TBXPreferences.ADD_TECH_LOGS, "" + false); //$NON-NLS-1$
+		TXMPreferences.putString(TBXPreferences.class.getCanonicalName(),TBXPreferences.LOG_STACKTRACE, "" + true); //$NON-NLS-1$
+		TXMPreferences.putString(TBXPreferences.class.getCanonicalName(),TBXPreferences.LOG_IN_FILE, "" + false); //$NON-NLS-1$
+		TXMPreferences.putString(TBXPreferences.class.getCanonicalName(),TBXPreferences.CQI_SERVER_ADDITIONAL_OPTIONS, "-b 1000000 -d OFF"); //$NON-NLS-1$
+		TXMPreferences.putString(TBXPreferences.class.getCanonicalName(),TBXPreferences.CQI_SERVER_PORT, "4877"); //$NON-NLS-1$
+		TXMPreferences.putString(TBXPreferences.class.getCanonicalName(),TBXPreferences.CQI_SERVER_HOST, "localhost"); //$NON-NLS-1$
+		TXMPreferences.putString(TBXPreferences.class.getCanonicalName(),TBXPreferences.CQI_SERVER_LOGIN, "anonymous"); //$NON-NLS-1$
+		TXMPreferences.putString(TBXPreferences.class.getCanonicalName(),TBXPreferences.CQI_SERVER_PASSWORD, ""); //$NON-NLS-1$
+		TXMPreferences.putString(TBXPreferences.class.getCanonicalName(),TBXPreferences.CQI_SERVER_IS_REMOTE, "" + false); //$NON-NLS-1$
+		TXMPreferences.putString(TBXPreferences.class.getCanonicalName(),TBXPreferences.CQI_NETWORK_MODE, "false"); //$NON-NLS-1$
+		TXMPreferences.putString(TBXPreferences.class.getCanonicalName(),TBXPreferences.CQP_EMPTY_VALUE_CODE, ""); //$NON-NLS-1$
+		TXMPreferences.putString(TBXPreferences.class.getCanonicalName(),TBXPreferences.UI_LOCALE, "fr"); //$NON-NLS-1$
+		TXMPreferences.putString(TBXPreferences.class.getCanonicalName(),TBXPreferences.TREETAGGER_INSTALL_PATH, System.getProperty("user.home") + "/TXM/treetagger"); //$NON-NLS-1$ //$NON-NLS-2$
+		TXMPreferences.putString(TBXPreferences.class.getCanonicalName(),TBXPreferences.TREETAGGER_MODELS_PATH, TXMPreferences.getString(TBXPreferences.class.getCanonicalName(),TBXPreferences.TREETAGGER_INSTALL_PATH) + "/models"); //$NON-NLS-1$
+		TXMPreferences.putString(TBXPreferences.class.getCanonicalName(),TBXPreferences.TREETAGGER_APOSTROPHE, "false"); //$NON-NLS-1$
+		TXMPreferences.putString(TBXPreferences.class.getCanonicalName(),TBXPreferences.METADATA_ENCODING, "UTF-8"); //$NON-NLS-1$
+		TXMPreferences.putString(TBXPreferences.class.getCanonicalName(),TBXPreferences.METADATA_TXTSEPARATOR, "\""); //$NON-NLS-1$
+	}
+}

Index: tmp/org.txm.core/src/java/org/txm/core/results/ITXMResult.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/core/results/ITXMResult.java	(revision 312)
+++ tmp/org.txm.core/src/java/org/txm/core/results/ITXMResult.java	(revision 313)
@@ -81,7 +81,14 @@
 	 */
 	public void setVisible(boolean visible);
 	
+	/**
+	 * Gets the children results specified by their class.
+	 * @param type
+	 * @return
+	 */
+	public ArrayList<ITXMResult> getResults(Class type);
 	
+	
 	/**
 	 * Gets the children results specified by their class.
 	 * @param type
Index: tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java	(revision 312)
+++ tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java	(revision 313)
@@ -18,7 +18,6 @@
 // At this moment, an empty list is created for children, to not return null when calling getChildren() 
 public abstract class TXMResult implements ITXMResult, Cloneable {
 	
-	
 	/**
 	 * The weight, essentially used for sorting purpose.
 	 */
@@ -168,7 +167,10 @@
 		return this.getResults(null, onlyVisible);
 	}
 
-	
+	@Override
+	synchronized public ArrayList<ITXMResult> getResults(Class type)	{
+		return TXMResult.getNodes(this.children, type, false);
+	}
 
 	@Override
 	synchronized public ArrayList<ITXMResult> getResults(Class type, boolean onlyVisible)	{
Index: tmp/org.txm.core/src/java/org/txm/Toolbox2.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/Toolbox2.java	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/Toolbox2.java	(revision 313)
@@ -0,0 +1,142 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate: 2017-01-24 18:11:42 +0100 (Tue, 24 Jan 2017) $
+// $LastChangedRevision: 3400 $
+// $LastChangedBy: mdecorde $ 
+//
+
+package org.txm;
+
+import java.io.File;
+import java.util.HashMap;
+import java.util.HashSet;
+
+import org.eclipse.core.runtime.CoreException;
+import org.eclipse.core.runtime.IConfigurationElement;
+import org.eclipse.core.runtime.Platform;
+import org.txm.objects.Workspace;
+import org.txm.utils.logger.Log;
+
+/**
+ * The Class Toolbox. A collection of static methods to initialize the toolbox
+ * 
+ * It initialize its engines Service
+ * 
+ * @author jmague, mdecorde, sjacquot
+ */
+public class Toolbox2 {
+
+	private static HashMap<Class, Engine> engines;
+
+	private static Workspace workspace;
+
+	// script engines : Groovy and more ? Python, etc.
+
+	public static boolean initialize() {
+		return stopEngines() && startsEngines() && stopWorkspace() && startWorkspace();
+	}
+
+	public static boolean shutdown() {
+		boolean ret = stopWorkspace() && stopEngines();
+		
+		engines.clear();
+		
+		return ret;
+	}
+
+	private static boolean startWorkspace() {
+		File xmlproject = new File(System.getProperty("osgi.user.area"), "default.xml");
+		workspace = new Workspace(xmlproject);
+		return workspace.load();
+	}
+
+	private static boolean stopWorkspace() {
+		if (workspace == null) return true;
+
+		boolean ret = workspace.save();
+
+		if (ret) workspace = null;
+
+		return ret;
+	}
+
+	public Engine getEngine(Class c) {
+		if (!engines.containsKey(c)) return null;
+
+		return engines.get(c);
+	}
+
+	private static boolean fetchEngines() {
+
+		IConfigurationElement[] contributions = Platform.getExtensionRegistry().getConfigurationElementsFor(Engine.ENGINE_EXTENSION_POINT_ID);
+
+		for(int i = 0; i < contributions.length; i++) {
+			try {
+				Log.info("Registering engine: "+contributions[i].getName());
+				Engine engine = (Engine)contributions[i].createExecutableExtension("class"); //$NON-NLS-1$
+				addEngine(engine);
+			}
+			catch(CoreException e) {
+				e.printStackTrace();
+			} 
+		}
+
+		return true;
+	}
+
+	private static boolean startsEngines() {
+		if (engines == null) fetchEngines();
+
+		boolean result = true;
+		for (Class c : engines.keySet()) {
+			Engine e = engines.get(c);
+			Log.info("Start&connect engine: "+e.getClass());
+			result = result && e.start() && e.connect();
+		}
+
+		return true;
+	}
+
+	private static void addEngine(Engine engine) {
+		engines.put(engine.getClass(), engine);
+	}
+
+	private static void removeEngine(Engine engine) {
+		engines.remove(engine.getClass());
+	}
+
+	private static boolean stopEngines() {
+		if (engines == null) return true;
+		if (engines.size() == 0) return true;
+
+		boolean result = true;
+		for (Class c : engines.keySet()) {
+			Engine e = engines.get(c);
+			Log.info("Disconnect&stop engine: "+e.getClass());
+			result = result && e.disconnect() && e.stop();
+		}
+
+		return true;
+	}
+}

Index: tmp/org.txm.core/src/java/org/txm/objects/BaseParameters.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/BaseParameters.java	(revision 312)
+++ tmp/org.txm.core/src/java/org/txm/objects/BaseParameters.java	(revision 313)
@@ -18,7 +18,6 @@
 import javax.xml.parsers.ParserConfigurationException;
 
 import org.txm.annotation.repository.SQLKnowledgeRepository;
-import org.txm.importer.xtz.ImportKeys;
 import org.txm.sql.SQLConnection;
 import org.txm.utils.xml.DomUtils;
 import org.txm.utils.logger.Log;
Index: tmp/org.txm.core/src/java/org/txm/objects/Corpus.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/Corpus.java	(revision 312)
+++ tmp/org.txm.core/src/java/org/txm/objects/Corpus.java	(revision 313)
@@ -43,6 +43,7 @@
 import org.txm.annotation.repository.KnowledgeRepository;
 import org.txm.annotation.repository.KnowledgeRepositoryManager;
 import org.txm.core.messages.TXMCoreMessages;
+import org.txm.core.preferences.TBXPreferences;
 import org.txm.functions.ProgressWatcher;
 import org.txm.metadatas.DateMetadata;
 import org.txm.metadatas.Metadata;
@@ -559,7 +560,7 @@
 	 */
 	public File getBaseDirectory()
 	{
-		String txmhome = Toolbox.getParam(Toolbox.USER_TXM_HOME);
+		String txmhome = Toolbox.getParam(TBXPreferences.USER_TXM_HOME);
 		Base base = this.getBase();
 		if (base != null)
 			return base.params.paramFile.getParentFile();
